/* Copyright (c) 2015 Latchable, Inc
 * 
 * Created by Vandita Sharma 12/09/2015
 *
 * latch_wdt.c
 */
 
/* this file contains the watch dog timer initialization and reloading code. 
*/

#include "latch.h"

void wdt_timer_handler(void *p_context)
{
  feed_the_dog();
}
void feed_the_dog()
{
  SEGGER_RTT_WriteString(0, "\033[2Jfeed the dog.\n\n");
  NRF_WDT->RR[0] = WDT_RELOAD_VALUE;  //Reload watchdog register 0 with reload value
}
void timers_init(void)
{
  // Initialize timer module
  APP_TIMER_INIT(APP_TIMER_PRESCALER, APP_TIMER_MAX_TIMERS, APP_TIMER_OP_QUEUE_SIZE, NULL);
}

void timers_start(void)
{
  uint32_t err_code;
  NRF_CLOCK->LFCLKSRC = NRF_CLOCK_LFCLKSRC_XTAL_20_PPM;
  NRF_CLOCK->TASKS_LFCLKSTART = 1;
  while (NRF_CLOCK->EVENTS_LFCLKSTARTED == 0);
  NRF_CLOCK->EVENTS_LFCLKSTARTED = 0;
  err_code = app_timer_create(&wdt_timer_id, APP_TIMER_MODE_REPEATED, wdt_timer_handler);
  APP_ERROR_CHECK(err_code); 
  err_code = app_timer_start(wdt_timer_id, TIMER_INTERVAL(WDT_TIMER_INTERVAL_MS), NULL);
  APP_ERROR_CHECK(err_code); 
}

void wdt_init(void)
{
  //approach 1
  timers_start();
  NRF_WDT->CONFIG = (WDT_CONFIG_HALT_Pause << WDT_CONFIG_HALT_Pos) | ( WDT_CONFIG_SLEEP_Run << WDT_CONFIG_SLEEP_Pos);
  NRF_WDT->CRV = WDT_TIMER_INTERVAL_MS*32.768;   //timeout in seconds * frequency
  NRF_WDT->RREN |= WDT_RREN_RR0_Msk;  //Enable reload register 0
  NRF_WDT->TASKS_START = 1;
  //approach 2
  /*NRF_WDT->CONFIG = (WDT_CONFIG_HALT_Pause << WDT_CONFIG_HALT_Pos) | ( WDT_CONFIG_SLEEP_Pause << WDT_CONFIG_SLEEP_Pos);
  NRF_WDT->CRV = WDT_TIMER_INTERVAL_MS*32.768;   //timeout in seconds * frequency
  NRF_WDT->RREN |= WDT_RREN_RR0_Msk;  //Enable reload register 0
  NRF_WDT->TASKS_START = 1;*/
}